package ch.hepia.numeric;
import java.util.List;
import java.util.ArrayList;

public class Transposed{
    private List<Double> vecT;

    public Transposed(){
        this.vecT = new ArrayList<>();
    };

    public Transposed(Vector That){
        this.vecT = new ArrayList<>();
        for (double elem : That.getValues()){vecT.add(elem);}
    };

     public List<Double> getValues(){
        return this.vecT;
    }
    
    public int len() {
        return this.getValues().size(); 
    }

    public double get(int i) {
        return this.getValues().get(i);
    }
    
    public double dot(Vector That){
        double res = 0.0;
        Integer count = 0;
        for (double coo : this.vecT) {
            res = res + (coo * That.get(count)); 
            count = count + 1;
        }
        return res;
        //throw new UnsupportedOperationException("This feature isn't implemented yet");
    };
    public Transposed sub(Transposed That){
        Transposed resT = new Transposed();
        Integer count = 0;
        for (double coo : this.getValues()) {
            resT.vecT.add(coo - That.getValues().get(count));
            count = count + 1;
        }
        return resT;
        //throw new UnsupportedOperationException("This feature isn't implemented yet");
    };

     @Override
    public String toString() {
        String tr = "Transposed[";
        for (double val: this.getValues()){
            tr = tr.concat(val + ", ");
        }
        tr = tr.substring(0, tr.length()-2).concat("]");
        return tr;
    }

    @Override
    public boolean equals(Object obj){
        if (this == obj) return true;
        if (obj == null || obj.getClass() != this.getClass()) {
            return false;
        }
        Transposed tra = (Transposed) obj;
        if (tra.len() != this.len()){
            return false;
        }
        for (int i=0;i<tra.len();i++){
            if (Double.compare(tra.getValues().get(i), this.getValues().get(i))!=0){
                return false;
            }
        }
        return true;
    }





}